/*global define,alert*/
define(
    [
        'Magento_Checkout/js/action/set-shipping-information',
        'Magento_Checkout/js/model/step-navigator',
        'Magento_Checkout/js/model/quote',
        'mage/translate'
    ],
    function (
        setShippingInformationAction,
        stepNavigator,
        quote,
        $t
    ) {
        'use strict';

        var mixin = {
            setShippingInformation: function () {
                if (quote.shippingAddress().custom_attributes) {
                    if (quote.shippingAddress().custom_attributes.location_id) {
                        if (quote.shippingAddress().custom_attributes.location_id === '__empty') {
                            alert($t('Please choose a shipping method location!'));
                            return false;
                        }
                    }
                }
                if (this.validateShippingInformation()) {
                    setShippingInformationAction().done(
                        function () {
                            stepNavigator.next();
                        }
                    );
                }
            }
        }

        return function (shipping) {
            return shipping.extend(mixin);
        };
    }
);